local set_frame_color4,current_alpha in _ENV

local fname = current_lua_file()
local dir = current_lua_dir()
local skinname = current_lua_dir_leaf():sub(2)

_ENV[skinname].LeaderFrame = function(_ENV)
depends(fname)

local frame = {}

depends 'ReportFrame'

add_resize_callback | function ()

  local layout_h in layout

  local mx,my,mw,mh = center_pane_rect()

  local y_content=12

  local height in bottom_bar
  height+=1
  
  --local w=round(min(mw*.9,height*3))-11


  local w = 1000

  local x=round(.5*(mw-w))+mx

  local fw=370

  local text_x=x+fw+15
  local text_w=w-fw-30

  local small_fonts in fonts
  local pt= 14

  local xpad = small_fonts and 10 or 15

  local xpad1=31

  local gen_w=text_w-xpad1-xpad

  local ypad = small_fonts and 5 or 7 

  local text_h=(height-20)

  text_w-=10

  insert(frame,..text_x,..text_h,..text_w,..pt,..gen_w,..xpad,..ypad,..y_content)

  frame.link_color={.5,.7,1}

  frame.actions = {
    baseline = fonts.small_fonts and 30 or 38,
    soft_left = text_x+w*.5*.25,
    soft_right = text_x+w*.5*.6,
    center = text_x+w*.25,
    pt= (fonts.small_fonts and 42 or 52)*layout.scale,
    font = fonts.secret,
    planet_force_x = mx+w*.5+mw*.5+20+planet_overlays.planet_w*.5
  }




  local r,g,b=str2color(bk_color or "0e335c")

  local h_scaled_vimage,asym1,clipped_box,vertical_line in _ENV

  frame.draw_leader = restore_color | function(leader_name)
    
    ReportFrame.draw_bk( frame.rect() )

    set_frame_color4(1,1,1,1)

    leader_name = leader_name or default_leader_portrait()

    drawers.LeaderDrawer.draw_for_report( leader_name, x+15,y_content,fw,text_h)
  end

  local x=mx+.5*(mw-w)
  frame.rect = catch(x,0,w,height)


  function frame.draw(links)

    ReportFrame.draw_frame | frame.rect()



    --asym1( mx+.5*(mw-w),0,w,height+6)
  end

end


return frame

end