UI_File | function(_ENV)

ship_hover_icon_spacing = weak_memoizeNN | function(w,h)



end


ship_hover_icon_spacing0 = weak_memoizeNN | function(w,h)

  local icon_radius_hint = 15
  local cx,cy=w*.5,h*.5

  local top_y=cy+h*.3


  local dy = 10
  
  -- need to pack the icons more closely
  if ( (2*dy)+6*icon_radius_hint > h )
    
    if 6*icon_radius_hint <= h
      dy = .5 * ( h - 6*icon_radius_hint )
      top_y = h-icon_radius_hint

    else
      dy=0
      icon_radius_hint = h/6
    end

  end


  local xoffset=max(w*.3,icon_radius_hint)
  local left_x = cx-xoffset
  local right_x=cx+xoffset

  local function left_hover_pos(p,i)
      return p.x+left_x, p.y+top_y-(i-1)*(dy+2*icon_radius_hint)
  end

  local function center_tooltip(p,hover_id,text)
    return draw_tooltip_cl(hover_id,p.x+cx,p.y+cy-5,text)
  end

  local function left_hover_tooltip(p,i,sub_tooltip_id, text)
    local x,y = left_hover_pos(p,i)

    return 
      draw_tooltip_cl(sub_tooltip_id,x+icon_radius_hint*1.4,y,text)
  end

  local function right_badge_pos(p,i)
    return p.x+right_x, p.y+top_y-(i-1)*(dy+2*icon_radius_hint)
  end

  local function right_badge_tooltip(p,i,sub_tooltip_id, text)
    local x,y = right_badge_pos(p,i)

    return 
      draw_tooltip_cr(sub_tooltip_id,x-icon_radius_hint*1.1,y,text)
  end

  return {
    ..icon_radius_hint,
    ..left_hover_pos,
    ..left_hover_tooltip,
    ..center_tooltip,
    ..right_badge_pos,
    ..right_badge_tooltip,
  }

end


draw_info_icon = restore_color | function (p,can_command,fleet)

  local x,y,w,h,ship,i in p 
  local hover_id=ship
  --local cx,cy=x+w*.5,y+h*.5



  --local rx,ry,rw,rh = box_grow(icon_radius_hint,icon_radius_hint,cx,cy,0,0)

  local alpha=hover_alpha_states.state[hover_id] or 0
  --local qy=cy+h*.3


  local left_icon_i=1
  local center_tooltip, icon_radius_hint, left_hover_pos,
     left_hover_tooltip,right_badge_pos,right_badge_tooltip in ship_hover_icon_spacing0(w,h)

  local right_icon_i=1

  if ship.inactive
   set_frame_color4(1,1,1,1)


   local icon = notification_icons.misc.sleep
--   icon=notification_icons.misc.question

   -- local sub_tooltip_id = recorded_name(ship)..' inactive'
    --draw_tooltip_cl(sub_tooltip_id,cx-w*.3+icon_radius_hint+5,qy,'Ship Information')

  SCOPE_call(
    ..icon_radius_hint,
    icon.draw_shadowed_icon,right_badge_pos(p,right_icon_i))



  
--   right_badge_tooltip(p,1,sub_tooltip_id,'Mercenary')

  -- draw_tooltip_cr(sub_tooltip_id,x-12,y,'Mercenary')
   --glBox | centered_box(x,qy,10,10)
   --draw_tooltip_cl(sub_tooltip_id,cx+w*.3+icon_radius_hint+5,qy,'Ship Information')   

   right_icon_i++
  end

  if ship.mercenary_empire
   set_frame_color4(1,1,1,1)


   local icon = notification_icons.logo.mercenary
--   icon=notification_icons.misc.question

    local sub_tooltip_id = recorded_name(ship)..' merc'
    --draw_tooltip_cl(sub_tooltip_id,cx-w*.3+icon_radius_hint+5,qy,'Ship Information')

   local el = element | SCOPE_call(
    ..icon_radius_hint,
    icon.draw_shadowed_icon,right_badge_pos(p,right_icon_i))


   el.tooltip_id=sub_tooltip_id
   
   --right_badge_pos(p,1)
  
   right_badge_tooltip(p,1,sub_tooltip_id,'Mercenary')

  -- draw_tooltip_cr(sub_tooltip_id,x-12,y,'Mercenary')
   el.on_click=ship_view
   el.ship=ship
   --glBox | centered_box(x,qy,10,10)
   --draw_tooltip_cl(sub_tooltip_id,cx+w*.3+icon_radius_hint+5,qy,'Ship Information')   
  end

  local sub_tooltip_id = recorded_name(ship)

  left_hover_tooltip(p,left_icon_i,sub_tooltip_id, 'Ship Information')

--  draw_tooltip_cl(sub_tooltip_id,cx-w*.3+icon_radius_hint+5,qy,'Ship Information')

  
  local el = element | SCOPE_frame_activation(alpha*frame_activation(),
      SCOPE_call,..icon_radius_hint,
        notification_icons.misc.question.draw, left_hover_pos(p,left_icon_i))
  left_icon_i++

  --set_frame_color4(1,1,1, alpha)

  --glBox(rx,ry,rw,rh)

  --set_frame_color4(1,1,1,alpha*frame_activation())

  --draw_tooltip_cl(hover_id,cx,cy-5,ship.tooltip_name)
  local eee_tooltip = ''
  for race,p ; ship.carrying_pop?
    eee_tooltip ..= format('\n  %s',race:gsub("^%l", string.upper))
	if p>0 then eee_tooltip ..= format('  %dx',p) end
  end
  --if string.len(eee_tooltip) > 0 then eee_tooltip = '\n'..eee_tooltip end
  SCOPE_call(text_width=400,center_tooltip,p,hover_id,ship.tooltip_name..eee_tooltip)


  --print(..rx,ry,rw,rh)

  insert(el,..hover_id,'tooltip_id',sub_tooltip_id)

  --glBox(rx,ry,rw,rh)

  el.ship=ship
  el.on_click= ship_view
  el.on_hover=help_cursor

  -- various transport specials
  if can_command



    local disembark_invalid,can_colonize_any,carried_ship,cant_unload_hab in ship

    if ship.empire==gui_player() and ship.pop_space



      if not (disembark_invalid or can_colonize_any)



        local sub_tooltip_id=recorded_name(ship) .. ' Disembark'


        local el = element | SCOPE_frame_activation(alpha*frame_activation(),
        SCOPE_call,..icon_radius_hint,
          notification_icons.misc.disembark.draw, left_hover_pos(p,left_icon_i))


        el.on_hover = purple_cursor
        el.on_click = disembark_click
        el.ship=ship
        insert(el,..hover_id,'tooltip_id',sub_tooltip_id)
        
        left_hover_tooltip(p,left_icon_i,sub_tooltip_id, 'Disembark Colonists')


--        draw_tooltip_cl(sub_tooltip_id,cx-w*.3+icon_radius_hint+5,y,'Disembark Colonists')
        left_icon_i++
      end

    end

		--!! unload hab options
    if ship.empire==gui_player() and ship.hab_space
			if not cant_unload_hab

        local sub_tooltip_id=recorded_name(ship) .. ' Unload'

        local el = element | SCOPE_frame_activation(alpha*frame_activation(),
        SCOPE_call,..icon_radius_hint,
          notification_icons.misc.disembark.draw, left_hover_pos(p,left_icon_i))

        el.on_hover = purple_cursor
        el.on_click = unload_hab_click
				        el.ship=ship
        insert(el,..hover_id,'tooltip_id',sub_tooltip_id)
        left_hover_tooltip(p,left_icon_i,sub_tooltip_id, 'Unload Habitat')
        left_icon_i++
			end
		end



    if carried_ship


      local star = at_star | fleet
      if star
        local r = light_report_search(fleet.empire,type='colonize',..star)
        if r?.outpost
           local sub_tooltip_id=recorded_name(ship) .. ' Build Outpost'
           local el = element | SCOPE_frame_activation(alpha*frame_activation(),
                SCOPE_call,..icon_radius_hint,
                  notification_icons.misc.orange_flag.draw, left_hover_pos(p,left_icon_i) )

            el.on_hover = purple_cursor
            el.on_click = report_click
            el.report = r

            insert(el,..hover_id,'tooltip_id',sub_tooltip_id)
        
            left_hover_tooltip(p,left_icon_i,sub_tooltip_id, 'Build Outpost')
            --print(..r,..report_click)
            left_icon_i++
        end
      end

    end

    if can_command and fleet and can_colonize_any
      
      local star = at_star | fleet
      if star

        local r = light_report_search(fleet.empire,type='colonize',..star)
       
        
        if r?.colonize
           local sub_tooltip_id=recorded_name(ship) .. ' Colonize Planet'
           local el = element | SCOPE_frame_activation(alpha*frame_activation(),
                SCOPE_call,..icon_radius_hint,
                  notification_icons.misc.colonization_flag.draw, left_hover_pos(p,left_icon_i) )

            el.on_hover = purple_cursor
            el.on_click = report_click
            el.report = r

            insert(el,..hover_id,'tooltip_id',sub_tooltip_id)
        
 
            left_hover_tooltip(p,left_icon_i,sub_tooltip_id, 'Colonize Planet')
            --print(..r,..report_click)

            left_icon_i++
        end  
        --print(..r)
      end

    end

    local trade_invalid = ship:cant_assign_to_trade()

    if not trade_invalid 

      local el = element | SCOPE_frame_activation(alpha*frame_activation(),
        SCOPE_call,..icon_radius_hint,
          notification_icons.misc.spaceship_colored.draw, left_hover_pos(p,left_icon_i) )

      local sub_tooltip_id=recorded_name(ship) .. ' Start Trading'
      insert(el,..hover_id,'tooltip_id',sub_tooltip_id,..fleet,..ship)
      el.on_hover = purple_cursor
      el.on_click = transport_assign_click
      
      left_hover_tooltip(p,left_icon_i,sub_tooltip_id, 'Start Trading')  

      left_icon_i++
    elseif ship.cargo_space

      local el = element | SCOPE_frame_activation(alpha*frame_activation(),
        SCOPE_call,..icon_radius_hint,
          notification_icons.misc.spaceship_grey.draw, left_hover_pos(p,left_icon_i) )

      local sub_tooltip_id=recorded_name(ship) .. ' Unable to Start Trading'
      insert(el,..hover_id,'tooltip_id',sub_tooltip_id)
      el.on_hover = grey_cursor
      el.on_click = nil
      el.ship=ship
    
      left_hover_tooltip(p,left_icon_i,sub_tooltip_id, |)
        format('Unable to Start Trading (%s)',trade_invalid)

      left_icon_i++
    end


    local embark_invalid,cant_load_hab in ship
    if not embark_invalid
        
      local el = element | SCOPE_frame_activation(alpha*frame_activation(),
        SCOPE_call,..icon_radius_hint,
          notification_icons.misc.embark.draw, left_hover_pos(p,left_icon_i) )

      local sub_tooltip_id=recorded_name(ship) .. ' Embark Colonists'
      insert(el,..hover_id,'tooltip_id',sub_tooltip_id,..ship,..fleet)
      el.on_hover = purple_cursor
      el.ship=ship

      left_hover_tooltip(p,left_icon_i,sub_tooltip_id, 'Embark Colonists')
      el.on_click=embark_click
      left_icon_i++
    end

    if not cant_load_hab
        
      local el = element | SCOPE_frame_activation(alpha*frame_activation(),
        SCOPE_call,..icon_radius_hint,
          notification_icons.misc.embark.draw, left_hover_pos(p,left_icon_i) )

      local sub_tooltip_id=recorded_name(ship) .. ' Load Habitat'
      insert(el,..hover_id,'tooltip_id',sub_tooltip_id,..ship,..fleet)
      el.on_hover = purple_cursor
      el.ship=ship

      left_hover_tooltip(p,left_icon_i,sub_tooltip_id, 'Load Habitat')
      el.on_click=load_hab_click
      left_icon_i++
    end

		if ship.drawer_table.mobile_station 
			if not ship:cant_enter_orbit()
				
				local el = element | SCOPE_frame_activation(alpha*frame_activation(),
					SCOPE_call,..icon_radius_hint,
						notification_icons.misc.enter_orbit.draw, left_hover_pos(p,left_icon_i) )

				local sub_tooltip_id=recorded_name(ship) .. ' Enter Orbit'
				insert(el,..hover_id,'tooltip_id',sub_tooltip_id,..ship,..fleet)
				el.on_hover = purple_cursor
				el.ship=ship

				left_hover_tooltip(p,left_icon_i,sub_tooltip_id, 'Enter Orbit')
				el.on_click=enter_orbit_click
				left_icon_i++

			end
		end



  end

 


end

end