local fname = current_lua_file()
local dir = current_lua_dir()
local skinname = current_lua_dir_leaf():sub(2)

_ENV[skinname].FleetPanel = function(_ENV)

depends(fname)

local panel = {}

add_resize_callback( function ()

	local cond,small_fonts in fonts

	local font in fonts!
	local fh = small_fonts and 48 or 64

	local h=bottom_bar.height

	local move_w=200

	insert(panel,..move_w)


	local ms=20
	local img=dir.."encounter_center.png"
	local w,ih=eimage_dims(img)
	local blue, orange, white, grey in action_colors

	local state2color = { 
		invalid=grey,
	}

	local warn_fh=small_fonts and 18 or 22

	panel.move_button = restore_color(function(x,text)

		local rx,ry,rw,rh = draw_expandN(dir.."encounter_center.png",
			x+ms,-6,
			round(.5*w),move_w-w-2*ms,nil,
			round(.8*ih),h-ih+4,nil);

		(state2color[state] or blue)()

		if text=="invalid"

			return hcentered_text(font,warn_fh,x+.5*move_w,h*.65,
				format("%sOutside\nCommand\n%sRange",
					add_kern(.8),add_kern(1) )
			)
				
		end


		hcentered_text(cond,fh,x+.5*move_w,h*.5,text or "Move")

    return rx,ry,rw,rh 
	end)


	panel.civ_move_button = restore_color(function(x,state)

		draw_expandN(dir.."encounter_center.png",
			x+ms,-6,
			round(.5*w),move_w-w-2*ms,nil,
			round(.8*ih),h-ih+4,nil);

		(state2color[state] or blue)()

		if state=="invalid"

			return hcentered_text(font,warn_fh,x+.5*move_w,h*.65,
				format("%sOutside\nCommand\n%sRange",
					add_kern(.8),add_kern(1) )
			)
				

		end

		local rx,ry,rw,rh=centered_text(cond,fh,x+.5*move_w,h*.7,format("%sChange\nDestination",add_kern(1.2)))

		--set_frame_color4(1,1,1,.1)
		--glBox(rx,ry,rw,rh)

		return rx,ry,rw,rh

	end)

end)


return panel

end