local centered_text, draw_expandN, eimage_dims in _ENV

local fname = current_lua_file()
local dir = current_lua_dir()
local skinname = current_lua_dir_leaf():sub(2)

_ENV[skinname].PlanetBar = function(_ENV)

depends 'NavFrame'
depends(fname)

local planet_bar = {}



add_resize_callback | function ()

  local cond,secret in fonts
  --local mw,layout_h in layout

  local layout_h in layout
  local mx,my,mw,mh = midscreen_rect()

  --print(..mw,..layout.layout_w)


  local function icolor()
    set_frame_color4(1,1,1,.5)
  end

  local font = "fonts/bitstream/vera.TTF"
  local bar_y = bottom_bar.height+10
  local bar_h = layout_h - top_bar.height-bar_y+8
  
  ---bar_y
  --local bar_fh = small_fonts and 18 or 22

  local bar_fh = 20

  local aspect_adj = mw/layout_h/4*3


  --print(..bar_fh)

  local bar_top = round(bar_fh*3.2)+16+8

  -- quick hack to assist with some of weirder aspect ratios
  local bar_w= round( min( (bar_h - 16) *.5805, mw*.4) )




  local bar_x = mx+mw-bar_w
  
  bar_w-=10
  bar_x+=4
  
  local bar_y1 = bar_y+bar_w-10



  --local split_bar = (mw/layout_h > 1.5 or bar_w<280) and small_fonts

  planet_bar.x=bar_x

  --console(..split_bar,..small_fonts)

  --console(bar_y1-bar_y,"vs",bar_h-bar_top-(bar_y1-bar_y),"vs",bar_top)


  --[[

  if split_bar

    local fname = dir .. "planet_bar_partial.png"
    
    bar_w=bar_top*5.5
    bar_x = mw-bar_w-8
    bar_y1=bar_y+10

    function planet_bar.frame()

      local iw,ih = eimage_dims(fname) 

      local dx = bar_w-iw
      local dy = bar_h-ih
      local tstretch = bar_top-58
      dy -= tstretch

      return draw_expandN(fname,
          bar_x,bar_y,
          34, dx, nil,
          161, dy, 
          299, tstretch)

    end


  else

  --]]

  function planet_bar.bar_rect()
    return bar_x,bar_y,bar_w,bar_h
  end

  function planet_bar.frame()
    SCOPE_call(
      top_bar_rect=top_bar.bar_rect,
      ..planet_bar,
      PlanetBar.draw,bar_x,bar_y,bar_w,bar_h)
    

  end

  --[[
  do

    local fname = dir .. "planet_bar2.png"

    function planet_bar.frame()


      local iw,ih = eimage_dims(fname) 

      local dx = bar_w-iw
      local dy = bar_h-ih
      local bstretch = bar_w-272-35
      local tstretch = bar_top-58
      dy -= tstretch+bstretch
      
      --console(..bstretch,..dy)

      return draw_expandN(fname,
          bar_x,bar_y,
          34, dx, nil,
          161, bstretch, dy>0 and 381 or 310, dy, 519, tstretch)

    end

  end
  --]]

  --[[
  function planet_bar.close_rect()
    local s=15
    return bar_x+bar_w-s,bar_y+bar_h-s,s,s
  end
  --]]


  local lower_bkc = string_color_fun("b6c7f433")
  local upper_bkc = string_color_fun("0d3a68e8")
  
  local function stats_rect()
    return bar_x+10, bar_y+bar_h-bar_top, bar_w-20, bar_top-6 
  end

  
--  local get_unique_id = weak_memoize_m_to_1 | function(...)
--    return {}
--  end







  do

    local xshift=22
    local x,y0,w,h=bar_x+xshift, bar_y+bar_h-bar_top+7, bar_w-xshift*2+6, bar_top*.45-8



    local y1=bar_y+bar_h-bar_fh*1.4-12

    function planet_bar.improvement_list_rect()
      return x,y0+bar_fh*.3,w,bar_fh
    end

    function planet_bar.defenses_rect()
      return x+w*.7,y1,.3*w,bar_fh
    end

    local tip_element = new_tip_maker { style = 'draw_center_left', dy=-6, dx=6 }
    local hammer_el = tip_element('Industry', desc_text='Factories')
    local coins_el = tip_element('Economy', desc_text='Income')
    local beakers_el = tip_element('Research', desc_text='Labs')

    function planet_bar.production_rect()
      return x,y1+4,w*.7,18
    end

    --[[
    function planet_bar.draw_production(hammers,coins,research)
      --glBox(x,y1,w,h)
      set_frame_color4(1,1,1,1)
      hammer_el | hammers_string(bar_fh,x,y1, tostring(hammers) )

      coins_el | coins_string(bar_fh,x+bar_fh*3.5,y1, tostring(coins) )

      beakers_el | beakers_string(bar_fh,x+bar_fh*7,y1, tostring(research) ) 

    end
    --]]

  end




  do

    local x,y,w,h=bar_x+10, bar_y+8, bar_w-20, (bar_y1- bar_y)-35

    planet_bar.production_h = h

    --print('lower h',h)

    function planet_bar.production_full_rect()
      return x,y,w,h
    end



    local production_fh = 16

    local fh=production_fh

    local by=round(58)

    function planet_bar.cannot_change_warning()
      hcentered_text(font,26, x+.5*w,y+by+6,"CANNOT CHANGE")
    end

    function planet_bar.production_rect_bk()

      return x,y+by,w,h-by
      --return box_grow(-2,-2,x,y+by-2,w,h-by-2)
    end

    function planet_bar.production_inset_rect()


      --glBox(x,y+by,w,h-by)
      return box_grow(-5,-4,x,y+by-1,w,h-by-1)
    end

    local r,g,b,a = str2color("0d3a68b6")


    planet_bar.production_title_bk = restore_color | function ()

      set_frame_color4(r,g,b,a)
      glBox(x, y, w, by)

      --set_frame_color4(1,1,1,a)
      --horizontal_line(x, y+by, w)
    end

    planet_bar.blockaded_text  = restore_color(function()
      set_frame_color4(1,.2,.1,1)
      return hcentered_text(font,26, x+.5*w,y+by+6,"BLOCKADED")
    end)

    planet_bar.metal_shortage_text  = restore_color(function()
      set_frame_color4(1,.4+sin(frame_time()*3)*.15, 0,1)
      return hcentered_text(font,26, x+.5*w,y+by+6,"INSUFFICIENT METAL")
    end)


    local fh=18
    local x0=x+fh*.8
    local y0=y+by-fh
    local x1=x+w-fh*9.1
    local y1=y0-fh*1.4

    function planet_bar.production_title(str,...)
      return display_text( font, production_fh,
        x0,y0, format(str,...)
       )
    end

    function planet_bar.turns_left(str,...)
      return display_text( font, production_fh,
        x1,y0, format(str,...)
       )
    end

    --[[
    function planet_bar.buy_text(str,...)

      return  ResourceGlyph.coin.suffixed(font, production_fh,
        x1,y1, format(str,...)
       )

    end

    local invalid_color = catch(1,1,1,.5)

    planet_bar.cant_buy_text = restore_color( function (str,...)

      return SCOPE_call(
        font_color =invalid_color,
        ResourceGlyph.coin.suffixed, 
          font, production_fh, x1,y1, format(str,...)
       )

    end)
    --]]

    function planet_bar.invalid_project_text(x,y,w,text)
      local word = planet_bar.text_context.lazy_word_render(
        'choose_box',text)
        
      return word.draw_hcentered(x+w*.5,y+w*.05)
    end

    planet_bar.buy_text = restore_color | function(can_buy,text)

      if not can_buy
        set_frame_color4(.6,.6,.6,1)
      end

      local word = planet_bar.text_context.lazy_word_render(
        'vera16',text)

      return word.draw(x1,y1)
    end


    function planet_bar.progress_text(str,discount_mult)
      local rx,ry,rw,rh = ResourceGlyph.wrench.suffixed(font,fh,x0,y1,str)
      if (discount_mult or 1)~=1
        --console(..discount_mult)
        display_text(fonts.font,fh,rx+rw+fh*.9,y1,format('(%d%% cost)',round | 100*discount_mult))
      end

      return 
    end

    function planet_bar.big_production_title(str)
      planet_bar.production_title_bk()
      return centered_text(secret,60,
        x+.5*w,y+.56*by,str)
    end


  end


  planet_bar.background = restore_color | function ()
    upper_bkc()
    glBox(  stats_rect() )
    
    lower_bkc( )


    glBox(  planet_bar.pop_rect() )


    glBox(  planet_bar.production_rect_bk() )
  end 

  local ph=bar_h- (split_bar and 30 or 100)
  local px=round( .5*(bar_x-ph))



  local py=bar_y+ (split_bar and 0 or 30)


  if(px<0)
    ph=bar_x-20
    px=round( .5*(bar_x-ph))
    py+=max(0,.6*(bar_h-(bar_y+ph+20)))
  end




  local pw=ph
  local info_w= bar_x-(px+pw) - 24

  --print(..info_w)
  local min_info_w=200
  if info_w < min_info_w
    pw -= min_info_w-info_w
  end

  --print(..info_w)

  planet_fh = small_fonts and 64 or 82

  if bar_x-px-pw > .5*bar_w
    px=round(bar_x-pw-.5*bar_w)
  end




  planet_bar.pop_h=bar_h-bar_top-(bar_y1- bar_y)-6 
  function planet_bar.pop_rect()
    return bar_x+10, bar_y1, bar_w-20, planet_bar.pop_h
  end



  local px=layout.scale~=1 and 2 or 0
--	local pw=pw*.9
--	local shift2=20
  
  px+=mx
  
    
  --planet_bar.choose_close = BigCloseButton( bar_x-35,bar_h+bar_y-20)
  --planet_bar.planet_close = BigCloseButton( px+pw-25,py+ph+30)

  --planet_bar.planet_rect = catch(px,py,pw,ph)
  --local planet_frame = gen_large_box(px,py,pw,ph)

  --planet_bar.planet_frame=planet_frame



  do

    local rx,ry,rw,rh=px,py,pw,ph
    local cx,cy,cw,ch = center_screen_rect()
    --ry-=28
    
    rh=ch-30
    rx+=2
    ry=bar_y
    --print(..rw)
    planet_bar.planet_h = rh

    planet_bar.planet_rect = catch(rx,ry,rw,rh)

    function planet_bar.planet_frame()
      HeavyFrame.draw_frame(rx,ry,rw,rh)
      --glBox(px,py,pw,ph)
    end

    function planet_bar.planet_bk_rect()
      return HeavyFrame.calc_bk_rect(rx,ry,rw,rh)   
    end

    planet_bar.planet_frame_rect = catch(rx,ry,rw,rh)


    local font, fh in fonts.race_selection_title

    planet_bar.planet_title_pick = catch(rx+105,ry+rh-60,rw-210,50)
    planet_bar.planet_title_rect = catch(rx,ry,rw,rh)

    function planet_bar.planet_frame_bk(str,planet)
    
      set_frame_color4(1,1,1,1)

      HeavyFrame.draw_bk(rx,ry,rw,rh)

      --HeavyFrame.draw_title(str,rx,ry,rw,rh)



      --local s=size2shift[size]*pw+60

      local s=50-planet.drawer_shift*(pw-50)

      return px+s,py+s,pw-2*s,ph-2*s
    end

  end



 local planet_choose_titles = new_text_rendering_context {
    name = 'planet choose titles',
 }

 planet_pane.choose_title = function(text,x,y)
   local word = planet_choose_titles.lazy_word_render('choose_box',text)
   word.draw_hcentered(x,y)
 end

  do
    local x=px+pw+12
    local w=bar_x-x-12
    
    --local y=py
    --local h=min( (ph-20)*.73, ph-220)
    
    local h = planet_bar.planet_h
    local y = bar_y

    local name = 'planet info'
    

--		local fx,fy,fw,fh=x,y,w,h

--		local frame_color = catch(str2color('dbdbdbaf'))
--    local dark_bk_color = catch(str2color('132447ad'))
    --local frame = wide_bottom_box(x,y,w,h)



    planet_bar.info_frame_rect = catch(x,y,w,h)

    planet_bar.info_area = catch(x+2,y+h-6,w-4, bar_y+bar_h - (y+h) )
    

    function planet_bar.long_info_prefix(key)
      return format('<h1>%s</h1>\n',key)
    end

    insert(planet_bar,..markup_text_fonts)

    local text_context = new_text_rendering_context {
      name = 'planet info',
      default_font_key = 'vera14',
      link_color = {1,1,1},
    }

    insert(planet_bar,..text_context)

    local vbox_list = framed_scrolling_vboxes {
      .. text_context,
      rect = catch | NavFrame.clipping_rect | planet_bar.info_frame_rect(),
    }
  
    for i=1,30

    vbox_list.add_vbox(function()
        glBox(10,10,100,10)
    end,30)

    end





    local scroll_position = NavFrame.make_scroll_position(
      vbox_list.scroll_area,
      planet_bar.info_frame_rect(),
    )

    do


      insert(planet_pane,info_text_vboxes=vbox_list)

      local current = planet_link_history.current()
      if current
        planet_pane.set_desc_text(current,planet_subpane)
      end

    end


    --local bar = RoundedScrollBar(x+w+9,y+2,h,scroll_area,_ENV)
    --local bar = FrameScrollBar(frame!.scroll_info, scroll_area,_ENV)

    push_zoom_handler | function(dz)

      --print(..dz,..planet_subpane,midscreen_pane==planet_pane)

      if planet_subpane==nil and midscreen_pane==planet_pane

        return vbox_list.scroll_area.handle_zoom_in_rect(dz,planet_bar.info_frame_rect())
        --
      end
    end



    planet_bar.planet_info = restore_color | function (text)
      --clipped_box(x,y,w,h,glWrap,draw,text)
      
--      set_frame_color4(dark_bk_color())

      NavFrame.frame.draw_bk | planet_bar.info_frame_rect()

 --     glBox(x,y,w,h)


      --glBox | planet_bar.info_frame_rect()
      --insert(element | planet_bar.info_frame_rect(),
      --  ..vbox_list.scroll_area.on_wheel)

  

      set_frame_color4(1,1,1,1)
      
      vbox_list.clipped_draw()

      --scroll_area.draw(text)


      --local prev_valid, next_valid= planet_link_history.valid_moves()

      --local do_arrows= prev_valid or next_valid
      --frame.draw()

      --print(planet_bar.info_area())

      NavFrame.draw_frame | planet_bar.info_frame_rect()
      
      scroll_position.draw()

      NavFrame.draw_arrows( planet_link_history, prev_planet_link, next_planet_link, planet_bar.info_frame_rect() )

      --glBox(vbox_list.rect())

      --[[

      local px,py,pw,ph,
          nx,ny,nw,nh = frame.draw_arrows( prev_valid,next_valid )


      insert(element(px,py,pw,ph),
        on_click=prev_valid and prev_planet_link,
        on_hover=prev_valid and hand_cursor or grey_cursor,
        )


      insert(element(nx,ny,nw,nh),
        on_click=next_valid and next_planet_link,
        on_hover=next_valid and hand_cursor or grey_cursor,
        )

        --]]

      --glBox(x,y,w,h)
    end
  end



end


return planet_bar

end